Bug 48687 - mod_rewrite ignores trailing dot in request URI on Windows platform
Summary: mod_rewrite ignores trailing dot in request URI on Windows platform
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_rewrite (show other bugs)
Version: 2.2.14
Hardware: PC Windows Server 2003
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2010-02-05 12:24 UTC by Christian Becker
Modified: 2018-11-07 21:08 UTC (History)
0 users



Attachments
mod_rewrite log (3.17 KB, text/plain)
2010-02-05 12:24 UTC, Christian Becker
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Christian Becker 2010-02-05 12:24:08 UTC
Created attachment 24932 [details]
mod_rewrite log

When the request URI contains a trailing dot, e.g. "http://localhost/items/Apple_Inc.", mod_rewrite will not see the dot and treat the URI as "http://localhost/items/Apple_Inc".

Given the above request URI and the following mod_rewrite configuration via .htaccess, the resulting redirect URL is "http://localhost/detail.html?item=Apple_Inc", i.e. the trailing dot is lost:

 RewriteEngine on
 RewriteRule ^items/(.*)$ /detail.html?item=$1 [R=301,L,QSA]

This was verified on a blank installation of the non-SSL 2.2.14 Windows distribution. Conversely, when the same version is built from source on Ubuntu Linux, the redirection works as intended.

Attached is a corresponding log of the above request with RewriteLogLevel 9.
The problem also appears for series of dots. If dots are followed by a non-alphanumeric character such as a forward slash, the dots disappear and only the slash prevails. If dots are followed by an alphanumeric character, they remain.
Comment 1 nounouille 2013-05-23 19:50:05 UTC
Hello,

Here is a workaround that uses RewriteCond instead of RewriteRule to parse the URL and this works!

RewriteEngine on
RewriteCond %{REQUEST_URI} ^/items/(.*)$
RewriteRule ^items/(.*)$ /detail.html?item=%1 [R=301,L,QSA]
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:12 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.